﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using OpenTK;
using OpenTK.Graphics.OpenGL;

namespace OpenTK_Test
{
	class Game : GameWindow
	{
		//int texture;
		Texture2D texture;

		View view;


		public Game(int width, int height)
			: base(width, height)
		{
			GL.Enable(EnableCap.Texture2D);

			this.view = new View(Vector2.Zero, 2.0, MathHelper.PiOver4);
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);

			this.texture = ContentPipe.LoadTexture("supwergirl.jpg");
		}

		protected override void OnUpdateFrame(FrameEventArgs e)
		{
			base.OnUpdateFrame(e);

			view.position.Y += 0.01f;

			view.Update();
		}

		protected override void OnRenderFrame(FrameEventArgs e)
		{
			base.OnRenderFrame(e);

			GL.Clear(ClearBufferMask.ColorBufferBit);
			GL.ClearColor(Color.CornflowerBlue);

			GL.LoadIdentity();
			view.ApplyTransform();

			//GL.BindTexture(TextureTarget.Texture2D, this.texture);
			GL.BindTexture(TextureTarget.Texture2D, this.texture.ID);
			GL.Begin(PrimitiveType.Quads);

			GL.Color3(Color.Red);
			GL.TexCoord2(0, 0);
			GL.Vertex2(0, 0);		//Top, Left

			GL.Color3(Color.Blue);
			GL.TexCoord2(1, 0);
			GL.Vertex2(0.9f, 0);		//Top, Right

			GL.Color3(Color.Orange);
			GL.TexCoord2(1, 1);
			GL.Vertex2(1, -0.9f);	//Bottom, Left

			GL.Color3(Color.Green);
			GL.TexCoord2(0, 1);
			GL.Vertex2(0, -1);		//Bottom, Right

			GL.End();

			this.SwapBuffers();
		}

	}
}
