﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using OpenTK;
using OpenTK.Graphics.OpenGL;
using System.Drawing;

namespace OpenTK_Test
{
	class View
	{
		public Vector2 position;
		/// <summary>
		/// 각도, + = 시계방향
		/// </summary>
		public double rotation;
		/// <summary>
		/// 확대
		/// 1 = 기본
		/// 2 = 2x 확대
		/// </summary>
		public double zoom;

		public View(Vector2 startPosition, double startZoom, double startRotation)
		{
			this.position = startPosition;
			this.zoom = startZoom;
			this.rotation = startRotation;
		
		}

		public void Update()
		{
		}

		public void ApplyTransform()
		{
			Matrix4 transform = Matrix4.Identity;

			transform = Matrix4.Mult(transform, Matrix4.CreateTranslation(-this.position.X, -this.position.Y, 0));
			transform = Matrix4.Mult(transform, Matrix4.CreateRotationZ(-(float)this.rotation));
			transform = Matrix4.Mult(transform, Matrix4.CreateScale((float)this.zoom, (float)zoom, 1.0f));

			GL.MultMatrix(ref transform);
		}

	}
}
